#ifndef XCHATOSDCONFH
#define XCHATOSDCONFH

#include <fstream>
#include <map>
#include <vector>
#include <cctype>
#include "xchatosd.h"

using namespace std;

class XOsdConf {
	public:
		XOsdConf::XOsdConf();
		XOsdConf::~XOsdConf();
		int read(string);
		int write(string);
		int getiValue(string);
		string getValue(string);
		int setValue(string,string);
		int setValue(string,int);
		bool isPossible(string);
		bool isValueOk(string, string);
		void erase();
		string lastError() {return __lasterr;};
	private:
		map<string,string> __data;
		vector<string> __possible;
		map<string,string> __params;
		map<string,string> __values;
		map<string,string> __alias;
		string __lasterr;
};

#endif
